Index: unk/sources/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Manipulators/SimpleLocalSearchManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Manipulators/SimpleLocalSearchManipulator.cs	(revision 4206)
+++ 	(revision )
@@ -1,88 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core;
-using HeuristicLab.Encodings.PermutationEncoding;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Data;
-using System;
-using System.Collections.Generic;
-
-namespace HeuristicLab.Problems.VehicleRouting.Encodings.Alba {
-  [Item("SimpleLocalSearchManipulator", "An operator which applies the SLS operation to an Alba VRP representation.  It is implemented as described in Alba, E. and Dorronsoro, B. (2004). Solving the Vehicle Routing Problem by Using Cellular Genetic Algorithms.")]
-  [StorableClass]
-  public sealed class SimpleLocalSearchManipulator : AlbaManipulator {   
-    [StorableConstructor]
-    private SimpleLocalSearchManipulator(bool deserializing) : base(deserializing) { }
-
-    public SimpleLocalSearchManipulator()
-      : base() {
-     }
-
-    public static void Apply(AlbaEncoding individual, int index1, int index2) {
-      if (index1 != -1 && index2 != -1) {
-        int breakPoint1 = index1 + 1;
-        int breakPoint2 = index2;
-        for (int i = 0; i <= (breakPoint2 - breakPoint1) / 2; i++) {  // invert permutation between breakpoints
-          int temp = individual[breakPoint1 + i];
-          individual[breakPoint1 + i] = individual[breakPoint2 - i];
-          individual[breakPoint2 - i] = temp;
-        }
-      }
-    }
-
-    protected override void Manipulate(IRandom rand, AlbaEncoding individual) {
-      int index1 = -1;
-      int index2 = -1;
-
-      List<Tour> validTours = new List<Tour>();
-      foreach (Tour tour in individual.Tours) {
-        if (tour.Cities.Count >= 4)
-          validTours.Add(tour);
-      }
-
-      if (validTours.Count > 0) {
-        Tour chosenTour = validTours[rand.Next(validTours.Count)];
-        int currentTourStart = -1;
-        for (int i = 0; i < individual.Length; i++) {
-          if (individual[i] + 1 == chosenTour.Cities[0]) {
-            currentTourStart = i;
-            break;
-          }
-        }
-
-        int currentTourEnd = currentTourStart;
-        while (currentTourEnd < individual.Length && 
-          individual[currentTourEnd] < individual.Cities) {
-          currentTourEnd++;
-        }
-
-        int tourLength = currentTourEnd - currentTourStart;
-        int a = rand.Next(tourLength - 3);
-        index1 = currentTourStart + a;
-        index2 = currentTourStart + rand.Next(a + 2, tourLength - 1);
-      }
-
-      Apply(individual, index1, index2);
-    }
-  }
-}
Index: unk/sources/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/Interfaces/IAlbaSimpleLocalSearchMoveOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/Interfaces/IAlbaSimpleLocalSearchMoveOperator.cs	(revision 4206)
+++ 	(revision )
@@ -1,30 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core;
-using HeuristicLab.Encodings.PermutationEncoding;
-using HeuristicLab.Optimization;
-
-namespace HeuristicLab.Problems.VehicleRouting.Encodings.Alba {
-  public interface IAlbaSimpleLocalSearchMoveOperator : IVRPMoveOperator {
-    ILookupParameter<SimpleLocalSearchMove> SimpleLocalSearchMoveParameter { get; }
-  }
-}